/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: ParserPackageImpl.java,v 1.13 2005/03/24 21:12:25 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.parser.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.emf.ecore.xml.type.XMLTypePackage;
import org.eclipse.emf.ecore.xml.type.impl.XMLTypePackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.adapter.AdapterPackage;
import org.eclipse.hyades.logging.adapter.model.internal.adapter.impl.AdapterPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.configuration.ConfigurationPackage;
import org.eclipse.hyades.logging.adapter.model.internal.configuration.impl.ConfigurationPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.context.ContextPackage;
import org.eclipse.hyades.logging.adapter.model.internal.context.impl.ContextPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.extractor.ExtractorPackage;
import org.eclipse.hyades.logging.adapter.model.internal.extractor.impl.ExtractorPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.filter.FilterPackage;

import org.eclipse.hyades.logging.adapter.model.internal.filter.impl.FilterPackageImpl;

import org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterPackage;
import org.eclipse.hyades.logging.adapter.model.internal.formatter.impl.FormatterPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage;
import org.eclipse.hyades.logging.adapter.model.internal.outputter.impl.OutputterPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot;
import org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType;
import org.eclipse.hyades.logging.adapter.model.internal.parser.ParserFactory;
import org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage;
import org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType;
import org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType;
import org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType;
import org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage;
import org.eclipse.hyades.logging.adapter.model.internal.sensor.impl.SensorPackageImpl;
import org.eclipse.hyades.logging.adapter.model.internal.unit.UnitPackage;
import org.eclipse.hyades.logging.adapter.model.internal.unit.impl.UnitPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ParserPackageImpl extends EPackageImpl implements ParserPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass parserConfigTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass ruleAttributeTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass ruleElementTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass substitutionRuleTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass documentRootEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private ParserPackageImpl() {
		super(eNS_URI, ParserFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this
	 * model, and for any others upon which it depends.  Simple
	 * dependencies are satisfied by calling this method on all
	 * dependent packages before doing anything else.  This method drives
	 * initialization for interdependent packages directly, in parallel
	 * with this package, itself.
	 * <p>Of this package and its interdependencies, all packages which
	 * have not yet been registered by their URI values are first created
	 * and registered.  The packages are then initialized in two steps:
	 * meta-model objects for all of the packages are created before any
	 * are initialized, since one package's meta-model objects may refer to
	 * those of another.
	 * <p>Invocation of this method will not affect any packages that have
	 * already been initialized.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static ParserPackage init() {
		if (isInited) return (ParserPackage)EPackage.Registry.INSTANCE.getEPackage(ParserPackage.eNS_URI);

		// Obtain or create and register package
		ParserPackageImpl theParserPackage = (ParserPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof ParserPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(eNS_URI) : new ParserPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		XMLTypePackageImpl.init();

		// Obtain or create and register interdependencies
		FilterPackageImpl theFilterPackage = (FilterPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FilterPackage.eNS_URI) instanceof FilterPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FilterPackage.eNS_URI) : FilterPackageImpl.eINSTANCE);
		AdapterPackageImpl theAdapterPackage = (AdapterPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AdapterPackage.eNS_URI) instanceof AdapterPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AdapterPackage.eNS_URI) : AdapterPackageImpl.eINSTANCE);
		ConfigurationPackageImpl theConfigurationPackage = (ConfigurationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ConfigurationPackage.eNS_URI) instanceof ConfigurationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ConfigurationPackage.eNS_URI) : ConfigurationPackageImpl.eINSTANCE);
		UnitPackageImpl theUnitPackage = (UnitPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI) instanceof UnitPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI) : UnitPackageImpl.eINSTANCE);
		ContextPackageImpl theContextPackage = (ContextPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ContextPackage.eNS_URI) instanceof ContextPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ContextPackage.eNS_URI) : ContextPackageImpl.eINSTANCE);
		ExtractorPackageImpl theExtractorPackage = (ExtractorPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ExtractorPackage.eNS_URI) instanceof ExtractorPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ExtractorPackage.eNS_URI) : ExtractorPackageImpl.eINSTANCE);
		FormatterPackageImpl theFormatterPackage = (FormatterPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FormatterPackage.eNS_URI) instanceof FormatterPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FormatterPackage.eNS_URI) : FormatterPackageImpl.eINSTANCE);
		OutputterPackageImpl theOutputterPackage = (OutputterPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(OutputterPackage.eNS_URI) instanceof OutputterPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(OutputterPackage.eNS_URI) : OutputterPackageImpl.eINSTANCE);
		SensorPackageImpl theSensorPackage = (SensorPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SensorPackage.eNS_URI) instanceof SensorPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SensorPackage.eNS_URI) : SensorPackageImpl.eINSTANCE);

		// Create package meta-data objects
		theParserPackage.createPackageContents();
		theFilterPackage.createPackageContents();
		theAdapterPackage.createPackageContents();
		theConfigurationPackage.createPackageContents();
		theUnitPackage.createPackageContents();
		theContextPackage.createPackageContents();
		theExtractorPackage.createPackageContents();
		theFormatterPackage.createPackageContents();
		theOutputterPackage.createPackageContents();
		theSensorPackage.createPackageContents();

		// Initialize created meta-data
		theParserPackage.initializePackageContents();
		theFilterPackage.initializePackageContents();
		theAdapterPackage.initializePackageContents();
		theConfigurationPackage.initializePackageContents();
		theUnitPackage.initializePackageContents();
		theContextPackage.initializePackageContents();
		theExtractorPackage.initializePackageContents();
		theFormatterPackage.initializePackageContents();
		theOutputterPackage.initializePackageContents();
		theSensorPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theParserPackage.freeze();

		return theParserPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getParserConfigType() {
		return parserConfigTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getParserConfigType_RuleElement() {
		return (EReference)parserConfigTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getParserConfigType_Description() {
		return (EAttribute)parserConfigTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getParserConfigType_DesignationToken() {
		return (EAttribute)parserConfigTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getParserConfigType_SeparatorToken() {
		return (EAttribute)parserConfigTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getParserConfigType_UniqueID() {
		return (EAttribute)parserConfigTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRuleAttributeType() {
		return ruleAttributeTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRuleAttributeType_SubstitutionRule() {
		return (EReference)ruleAttributeTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRuleAttributeType_DefaultValue() {
		return (EAttribute)ruleAttributeTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRuleAttributeType_Id() {
		return (EAttribute)ruleAttributeTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRuleAttributeType_Index() {
		return (EAttribute)ruleAttributeTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRuleAttributeType_IsRequiredByParent() {
		return (EAttribute)ruleAttributeTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRuleAttributeType_Name() {
		return (EAttribute)ruleAttributeTypeEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRuleAttributeType_UsePreviousMatchSubstitutionAsDefault() {
		return (EAttribute)ruleAttributeTypeEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRuleElementType() {
		return ruleElementTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRuleElementType_RuleElement() {
		return (EReference)ruleElementTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRuleElementType_RuleAttribute() {
		return (EReference)ruleElementTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRuleElementType_Id() {
		return (EAttribute)ruleElementTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRuleElementType_Index() {
		return (EAttribute)ruleElementTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRuleElementType_IsChildChoice() {
		return (EAttribute)ruleElementTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRuleElementType_IsRequiredByParent() {
		return (EAttribute)ruleElementTypeEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRuleElementType_Name() {
		return (EAttribute)ruleElementTypeEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSubstitutionRuleType() {
		return substitutionRuleTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSubstitutionRuleType_Match() {
		return (EAttribute)substitutionRuleTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSubstitutionRuleType_Positions() {
		return (EAttribute)substitutionRuleTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSubstitutionRuleType_Substitute() {
		return (EAttribute)substitutionRuleTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSubstitutionRuleType_SubstitutionExtensionClass() {
		return (EAttribute)substitutionRuleTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSubstitutionRuleType_TimeFormat() {
		return (EAttribute)substitutionRuleTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSubstitutionRuleType_UseBuiltInFunction() {
		return (EAttribute)substitutionRuleTypeEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDocumentRoot() {
		return documentRootEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDocumentRoot_Mixed() {
		return (EAttribute)documentRootEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_XMLNSPrefixMap() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_XSISchemaLocation() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_RuleAttribute() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_RuleElement() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ParserFactory getParserFactory() {
		return (ParserFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		parserConfigTypeEClass = createEClass(PARSER_CONFIG_TYPE);
		createEReference(parserConfigTypeEClass, PARSER_CONFIG_TYPE__RULE_ELEMENT);
		createEAttribute(parserConfigTypeEClass, PARSER_CONFIG_TYPE__DESCRIPTION);
		createEAttribute(parserConfigTypeEClass, PARSER_CONFIG_TYPE__DESIGNATION_TOKEN);
		createEAttribute(parserConfigTypeEClass, PARSER_CONFIG_TYPE__SEPARATOR_TOKEN);
		createEAttribute(parserConfigTypeEClass, PARSER_CONFIG_TYPE__UNIQUE_ID);

		ruleAttributeTypeEClass = createEClass(RULE_ATTRIBUTE_TYPE);
		createEReference(ruleAttributeTypeEClass, RULE_ATTRIBUTE_TYPE__SUBSTITUTION_RULE);
		createEAttribute(ruleAttributeTypeEClass, RULE_ATTRIBUTE_TYPE__DEFAULT_VALUE);
		createEAttribute(ruleAttributeTypeEClass, RULE_ATTRIBUTE_TYPE__ID);
		createEAttribute(ruleAttributeTypeEClass, RULE_ATTRIBUTE_TYPE__INDEX);
		createEAttribute(ruleAttributeTypeEClass, RULE_ATTRIBUTE_TYPE__IS_REQUIRED_BY_PARENT);
		createEAttribute(ruleAttributeTypeEClass, RULE_ATTRIBUTE_TYPE__NAME);
		createEAttribute(ruleAttributeTypeEClass, RULE_ATTRIBUTE_TYPE__USE_PREVIOUS_MATCH_SUBSTITUTION_AS_DEFAULT);

		ruleElementTypeEClass = createEClass(RULE_ELEMENT_TYPE);
		createEReference(ruleElementTypeEClass, RULE_ELEMENT_TYPE__RULE_ELEMENT);
		createEReference(ruleElementTypeEClass, RULE_ELEMENT_TYPE__RULE_ATTRIBUTE);
		createEAttribute(ruleElementTypeEClass, RULE_ELEMENT_TYPE__ID);
		createEAttribute(ruleElementTypeEClass, RULE_ELEMENT_TYPE__INDEX);
		createEAttribute(ruleElementTypeEClass, RULE_ELEMENT_TYPE__IS_CHILD_CHOICE);
		createEAttribute(ruleElementTypeEClass, RULE_ELEMENT_TYPE__IS_REQUIRED_BY_PARENT);
		createEAttribute(ruleElementTypeEClass, RULE_ELEMENT_TYPE__NAME);

		substitutionRuleTypeEClass = createEClass(SUBSTITUTION_RULE_TYPE);
		createEAttribute(substitutionRuleTypeEClass, SUBSTITUTION_RULE_TYPE__MATCH);
		createEAttribute(substitutionRuleTypeEClass, SUBSTITUTION_RULE_TYPE__POSITIONS);
		createEAttribute(substitutionRuleTypeEClass, SUBSTITUTION_RULE_TYPE__SUBSTITUTE);
		createEAttribute(substitutionRuleTypeEClass, SUBSTITUTION_RULE_TYPE__SUBSTITUTION_EXTENSION_CLASS);
		createEAttribute(substitutionRuleTypeEClass, SUBSTITUTION_RULE_TYPE__TIME_FORMAT);
		createEAttribute(substitutionRuleTypeEClass, SUBSTITUTION_RULE_TYPE__USE_BUILT_IN_FUNCTION);

		documentRootEClass = createEClass(DOCUMENT_ROOT);
		createEAttribute(documentRootEClass, DOCUMENT_ROOT__MIXED);
		createEReference(documentRootEClass, DOCUMENT_ROOT__XMLNS_PREFIX_MAP);
		createEReference(documentRootEClass, DOCUMENT_ROOT__XSI_SCHEMA_LOCATION);
		createEReference(documentRootEClass, DOCUMENT_ROOT__RULE_ATTRIBUTE);
		createEReference(documentRootEClass, DOCUMENT_ROOT__RULE_ELEMENT);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		XMLTypePackageImpl theXMLTypePackage = (XMLTypePackageImpl)EPackage.Registry.INSTANCE.getEPackage(XMLTypePackage.eNS_URI);

		// Add supertypes to classes

		// Initialize classes and features; add operations and parameters
		initEClass(parserConfigTypeEClass, ParserConfigType.class, "ParserConfigType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getParserConfigType_RuleElement(), this.getRuleElementType(), null, "ruleElement", null, 0, -1, ParserConfigType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getParserConfigType_Description(), theXMLTypePackage.getString(), "description", null, 0, 1, ParserConfigType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getParserConfigType_DesignationToken(), theXMLTypePackage.getString(), "designationToken", null, 0, 1, ParserConfigType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getParserConfigType_SeparatorToken(), theXMLTypePackage.getString(), "separatorToken", null, 0, 1, ParserConfigType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getParserConfigType_UniqueID(), theXMLTypePackage.getString(), "uniqueID", null, 1, 1, ParserConfigType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(ruleAttributeTypeEClass, RuleAttributeType.class, "RuleAttributeType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRuleAttributeType_SubstitutionRule(), this.getSubstitutionRuleType(), null, "substitutionRule", null, 0, -1, RuleAttributeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRuleAttributeType_DefaultValue(), theXMLTypePackage.getString(), "defaultValue", null, 0, 1, RuleAttributeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRuleAttributeType_Id(), theXMLTypePackage.getInteger(), "id", null, 0, 1, RuleAttributeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRuleAttributeType_Index(), theXMLTypePackage.getString(), "index", null, 0, 1, RuleAttributeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRuleAttributeType_IsRequiredByParent(), theXMLTypePackage.getBoolean(), "isRequiredByParent", "false", 0, 1, RuleAttributeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRuleAttributeType_Name(), theXMLTypePackage.getString(), "name", null, 1, 1, RuleAttributeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRuleAttributeType_UsePreviousMatchSubstitutionAsDefault(), theXMLTypePackage.getBoolean(), "usePreviousMatchSubstitutionAsDefault", null, 0, 1, RuleAttributeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(ruleElementTypeEClass, RuleElementType.class, "RuleElementType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRuleElementType_RuleElement(), this.getRuleElementType(), null, "ruleElement", null, 0, -1, RuleElementType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRuleElementType_RuleAttribute(), this.getRuleAttributeType(), null, "ruleAttribute", null, 0, -1, RuleElementType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRuleElementType_Id(), theXMLTypePackage.getInteger(), "id", null, 0, 1, RuleElementType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRuleElementType_Index(), theXMLTypePackage.getString(), "index", null, 0, 1, RuleElementType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRuleElementType_IsChildChoice(), theXMLTypePackage.getBoolean(), "isChildChoice", "false", 0, 1, RuleElementType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRuleElementType_IsRequiredByParent(), theXMLTypePackage.getBoolean(), "isRequiredByParent", "false", 0, 1, RuleElementType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRuleElementType_Name(), theXMLTypePackage.getString(), "name", null, 1, 1, RuleElementType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(substitutionRuleTypeEClass, SubstitutionRuleType.class, "SubstitutionRuleType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSubstitutionRuleType_Match(), theXMLTypePackage.getString(), "match", null, 0, 1, SubstitutionRuleType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSubstitutionRuleType_Positions(), theXMLTypePackage.getString(), "positions", null, 0, 1, SubstitutionRuleType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSubstitutionRuleType_Substitute(), theXMLTypePackage.getString(), "substitute", null, 0, 1, SubstitutionRuleType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSubstitutionRuleType_SubstitutionExtensionClass(), theXMLTypePackage.getString(), "substitutionExtensionClass", null, 0, 1, SubstitutionRuleType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSubstitutionRuleType_TimeFormat(), theXMLTypePackage.getString(), "timeFormat", null, 0, 1, SubstitutionRuleType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSubstitutionRuleType_UseBuiltInFunction(), theXMLTypePackage.getBoolean(), "useBuiltInFunction", null, 0, 1, SubstitutionRuleType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(documentRootEClass, DocumentRoot.class, "DocumentRoot", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDocumentRoot_Mixed(), ecorePackage.getEFeatureMapEntry(), "mixed", null, 0, -1, null, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_XMLNSPrefixMap(), ecorePackage.getEStringToStringMapEntry(), null, "xMLNSPrefixMap", null, 0, -1, null, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_XSISchemaLocation(), ecorePackage.getEStringToStringMapEntry(), null, "xSISchemaLocation", null, 0, -1, null, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_RuleAttribute(), this.getRuleAttributeType(), null, "ruleAttribute", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_RuleElement(), this.getRuleElementType(), null, "ruleElement", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http:///org/eclipse/emf/ecore/util/ExtendedMetaData
		createExtendedMetaDataAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http:///org/eclipse/emf/ecore/util/ExtendedMetaData</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createExtendedMetaDataAnnotations() {
		String source = "http:///org/eclipse/emf/ecore/util/ExtendedMetaData";				
		addAnnotation
		  (parserConfigTypeEClass, 
		   source, 
		   new String[] {
			 "name", "ParserConfigType",
			 "kind", "elementOnly"
		   });		
		addAnnotation
		  (getParserConfigType_RuleElement(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "RuleElement",
			 "namespace", "##targetNamespace"
		   });		
		addAnnotation
		  (getParserConfigType_Description(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "description"
		   });		
		addAnnotation
		  (getParserConfigType_DesignationToken(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "designationToken"
		   });		
		addAnnotation
		  (getParserConfigType_SeparatorToken(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "separatorToken"
		   });		
		addAnnotation
		  (getParserConfigType_UniqueID(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "uniqueID"
		   });			
		addAnnotation
		  (ruleAttributeTypeEClass, 
		   source, 
		   new String[] {
			 "name", "RuleAttributeType",
			 "kind", "elementOnly"
		   });		
		addAnnotation
		  (getRuleAttributeType_SubstitutionRule(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "SubstitutionRule"
		   });			
		addAnnotation
		  (getRuleAttributeType_DefaultValue(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "defaultValue"
		   });		
		addAnnotation
		  (getRuleAttributeType_Id(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "id"
		   });		
		addAnnotation
		  (getRuleAttributeType_Index(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "index"
		   });			
		addAnnotation
		  (getRuleAttributeType_IsRequiredByParent(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "isRequiredByParent"
		   });		
		addAnnotation
		  (getRuleAttributeType_Name(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "name"
		   });			
		addAnnotation
		  (getRuleAttributeType_UsePreviousMatchSubstitutionAsDefault(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "usePreviousMatchSubstitutionAsDefault"
		   });			
		addAnnotation
		  (ruleElementTypeEClass, 
		   source, 
		   new String[] {
			 "name", "RuleElementType",
			 "kind", "elementOnly"
		   });		
		addAnnotation
		  (getRuleElementType_RuleElement(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "RuleElement",
			 "namespace", "##targetNamespace"
		   });		
		addAnnotation
		  (getRuleElementType_RuleAttribute(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "RuleAttribute",
			 "namespace", "##targetNamespace"
		   });		
		addAnnotation
		  (getRuleElementType_Id(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "id"
		   });		
		addAnnotation
		  (getRuleElementType_Index(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "index"
		   });		
		addAnnotation
		  (getRuleElementType_IsChildChoice(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "isChildChoice"
		   });		
		addAnnotation
		  (getRuleElementType_IsRequiredByParent(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "isRequiredByParent"
		   });		
		addAnnotation
		  (getRuleElementType_Name(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "name"
		   });		
		addAnnotation
		  (substitutionRuleTypeEClass, 
		   source, 
		   new String[] {
			 "name", "SubstitutionRule_._type",
			 "kind", "empty"
		   });			
		addAnnotation
		  (getSubstitutionRuleType_Match(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "match"
		   });			
		addAnnotation
		  (getSubstitutionRuleType_Positions(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "positions"
		   });			
		addAnnotation
		  (getSubstitutionRuleType_Substitute(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "substitute"
		   });			
		addAnnotation
		  (getSubstitutionRuleType_SubstitutionExtensionClass(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "substitutionExtensionClass"
		   });			
		addAnnotation
		  (getSubstitutionRuleType_TimeFormat(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "timeFormat"
		   });			
		addAnnotation
		  (getSubstitutionRuleType_UseBuiltInFunction(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "useBuiltInFunction"
		   });		
		addAnnotation
		  (documentRootEClass, 
		   source, 
		   new String[] {
			 "name", "",
			 "kind", "mixed"
		   });		
		addAnnotation
		  (getDocumentRoot_Mixed(), 
		   source, 
		   new String[] {
			 "kind", "elementWildcard",
			 "name", ":mixed"
		   });		
		addAnnotation
		  (getDocumentRoot_XMLNSPrefixMap(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "xmlns:prefix"
		   });		
		addAnnotation
		  (getDocumentRoot_XSISchemaLocation(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "xsi:schemaLocation"
		   });		
		addAnnotation
		  (getDocumentRoot_RuleAttribute(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "RuleAttribute",
			 "namespace", "##targetNamespace"
		   });		
		addAnnotation
		  (getDocumentRoot_RuleElement(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "RuleElement",
			 "namespace", "##targetNamespace"
		   });
	}

} //ParserPackageImpl
