/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: SensorType.java,v 1.10 2005/03/24 21:12:27 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.sensor;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 *      The basic sensor types that are understood
 * <!-- end-model-doc -->
 * @see org.eclipse.hyades.logging.adapter.model.internal.sensor.SensorPackage#getSensorType()
 * @model
 * @generated
 */
public final class SensorType extends AbstractEnumerator {
	/**
	 * The '<em><b>Adapter CBE Sensor</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ADAPTER_CBE_SENSOR_LITERAL
	 * @model name="AdapterCBESensor"
	 * @generated
	 * @ordered
	 */
	public static final int ADAPTER_CBE_SENSOR = 0;

	/**
	 * The '<em><b>Single File Sensor</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SINGLE_FILE_SENSOR_LITERAL
	 * @model name="SingleFileSensor"
	 * @generated
	 * @ordered
	 */
	public static final int SINGLE_FILE_SENSOR = 1;

	/**
	 * The '<em><b>Static Parser Sensor</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STATIC_PARSER_SENSOR_LITERAL
	 * @model name="StaticParserSensor"
	 * @generated
	 * @ordered
	 */
	public static final int STATIC_PARSER_SENSOR = 2;

	/**
	 * The '<em><b>Undeclared</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #UNDECLARED_LITERAL
	 * @model name="undeclared"
	 * @generated
	 * @ordered
	 */
	public static final int UNDECLARED = 3;

	/**
	 * The '<em><b>Adapter CBE Sensor</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Adapter CBE Sensor</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ADAPTER_CBE_SENSOR
	 * @generated
	 * @ordered
	 */
	public static final SensorType ADAPTER_CBE_SENSOR_LITERAL = new SensorType(ADAPTER_CBE_SENSOR, "AdapterCBESensor");

	/**
	 * The '<em><b>Single File Sensor</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Single File Sensor</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SINGLE_FILE_SENSOR
	 * @generated
	 * @ordered
	 */
	public static final SensorType SINGLE_FILE_SENSOR_LITERAL = new SensorType(SINGLE_FILE_SENSOR, "SingleFileSensor");

	/**
	 * The '<em><b>Static Parser Sensor</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Static Parser Sensor</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STATIC_PARSER_SENSOR
	 * @generated
	 * @ordered
	 */
	public static final SensorType STATIC_PARSER_SENSOR_LITERAL = new SensorType(STATIC_PARSER_SENSOR, "StaticParserSensor");

	/**
	 * The '<em><b>Undeclared</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Undeclared</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #UNDECLARED
	 * @generated
	 * @ordered
	 */
	public static final SensorType UNDECLARED_LITERAL = new SensorType(UNDECLARED, "undeclared");

	/**
	 * An array of all the '<em><b>Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final SensorType[] VALUES_ARRAY =
		new SensorType[] {
			ADAPTER_CBE_SENSOR_LITERAL,
			SINGLE_FILE_SENSOR_LITERAL,
			STATIC_PARSER_SENSOR_LITERAL,
			UNDECLARED_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SensorType get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			SensorType result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Type</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SensorType get(int value) {
		switch (value) {
			case ADAPTER_CBE_SENSOR: return ADAPTER_CBE_SENSOR_LITERAL;
			case SINGLE_FILE_SENSOR: return SINGLE_FILE_SENSOR_LITERAL;
			case STATIC_PARSER_SENSOR: return STATIC_PARSER_SENSOR_LITERAL;
			case UNDECLARED: return UNDECLARED_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private SensorType(int value, String name) {
		super(value, name);
	}

} //SensorType
