/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: CBEMsgDataElement.java,v 1.9 2005/05/09 05:05:15 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.cbe;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Msg Data Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * When an event is used to represent a message, a message data element captures the several parts of the message information. For example "RDB2742E: an Error was detected in foo indicating that bar had problems" which has a msg id as well as substituted "foo" and "bar"  variables. 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgId <em>Msg Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgIdType <em>Msg Id Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalogId <em>Msg Catalog Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalogTokens <em>Msg Catalog Tokens</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalog <em>Msg Catalog</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgLocale <em>Msg Locale</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalogType <em>Msg Catalog Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEMsgDataElement()
 * @model 
 * @generated
 */
public interface CBEMsgDataElement extends EObject{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "";

	/**
	 * Returns the value of the '<em><b>Msg Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Msg Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * ZThis is where you would find the RDB1234E string that identifies the message.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Msg Id</em>' attribute.
	 * @see #setMsgId(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEMsgDataElement_MsgId()
	 * @model 
	 * @generated
	 */
	String getMsgId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgId <em>Msg Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Msg Id</em>' attribute.
	 * @see #getMsgId()
	 * @generated
	 */
	void setMsgId(String value);

	/**
	 * Returns the value of the '<em><b>Msg Id Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Msg Id Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * the id type is used to indicate the structure of the message id. for example IBM341 indicates a 3 charactercomponent id (RDB), a 4 charcter number (1234), and a 1 character severity level (E) making up the example RDB1234E. 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Msg Id Type</em>' attribute.
	 * @see #setMsgIdType(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEMsgDataElement_MsgIdType()
	 * @model 
	 * @generated
	 */
	String getMsgIdType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgIdType <em>Msg Id Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Msg Id Type</em>' attribute.
	 * @see #getMsgIdType()
	 * @generated
	 */
	void setMsgIdType(String value);

	/**
	 * Returns the value of the '<em><b>Msg Catalog Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Msg Catalog Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * A 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Msg Catalog Id</em>' attribute.
	 * @see #setMsgCatalogId(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEMsgDataElement_MsgCatalogId()
	 * @model 
	 * @generated
	 */
	String getMsgCatalogId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalogId <em>Msg Catalog Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Msg Catalog Id</em>' attribute.
	 * @see #getMsgCatalogId()
	 * @generated
	 */
	void setMsgCatalogId(String value);

	/**
	 * Returns the value of the '<em><b>Msg Catalog Tokens</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.String}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Msg Catalog Tokens</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Msg Catalog Tokens</em>' attribute list.
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEMsgDataElement_MsgCatalogTokens()
	 * @model type="java.lang.String"
	 * @generated
	 */
	EList getMsgCatalogTokens();

	/**
	 * Returns the value of the '<em><b>Msg Catalog</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Msg Catalog</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Msg Catalog</em>' attribute.
	 * @see #setMsgCatalog(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEMsgDataElement_MsgCatalog()
	 * @model 
	 * @generated
	 */
	String getMsgCatalog();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalog <em>Msg Catalog</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Msg Catalog</em>' attribute.
	 * @see #getMsgCatalog()
	 * @generated
	 */
	void setMsgCatalog(String value);

	/**
	 * Returns the value of the '<em><b>Msg Locale</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Msg Locale</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Msg Locale</em>' attribute.
	 * @see #setMsgLocale(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEMsgDataElement_MsgLocale()
	 * @model 
	 * @generated
	 */
	String getMsgLocale();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgLocale <em>Msg Locale</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Msg Locale</em>' attribute.
	 * @see #getMsgLocale()
	 * @generated
	 */
	void setMsgLocale(String value);

	/**
	 * Returns the value of the '<em><b>Msg Catalog Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Msg Catalog Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Msg Catalog Type</em>' attribute.
	 * @see #setMsgCatalogType(String)
	 * @see org.eclipse.hyades.models.cbe.CBEPackage#getCBEMsgDataElement_MsgCatalogType()
	 * @model 
	 * @generated
	 */
	String getMsgCatalogType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalogType <em>Msg Catalog Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Msg Catalog Type</em>' attribute.
	 * @see #getMsgCatalogType()
	 * @generated
	 */
	void setMsgCatalogType(String value);

} // CBEMsgDataElement
