/*******************************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IMethod.java,v 1.3 2005/02/16 22:21:15 qiyanli Exp $
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.hyades.models.common.facades.behavioral;

/**
 * A method is an operation of the class repressented by the deployable 
 * component.
 * 
 * @author jtoomey
 * @author psun
 *
 */
public interface IMethod extends INamedElement {
	
	/**
	 * Returns the deployable component to which this method belongs.
	 * 
	 * @returns IDeployableComponent
	 *
	 */	
	public IDeployableComponent getDeployableComponent();

}
