/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: Common_Behavior_FragmentsFactoryImpl.java,v 1.14 2005/03/28 21:51:32 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.fragments.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.hyades.models.common.fragments.*;

import org.eclipse.hyades.models.common.fragments.BVRCombinedFragment;
import org.eclipse.hyades.models.common.fragments.BVRGate;
import org.eclipse.hyades.models.common.fragments.BVRInteraction;
import org.eclipse.hyades.models.common.fragments.BVRInteractionConstraint;
import org.eclipse.hyades.models.common.fragments.BVRInteractionOccurrence;
import org.eclipse.hyades.models.common.fragments.BVRInteractionOperand;
import org.eclipse.hyades.models.common.fragments.BVRInteractionOperator;
import org.eclipse.hyades.models.common.fragments.BVRPartDecomposition;
import org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsFactory;
import org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class Common_Behavior_FragmentsFactoryImpl extends EFactoryImpl implements Common_Behavior_FragmentsFactory
{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "";

	/**
	 * Creates and instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_Behavior_FragmentsFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE: return createBVRInteractionOccurrence();
			case Common_Behavior_FragmentsPackage.BVR_PART_DECOMPOSITION: return createBVRPartDecomposition();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERAND: return createBVRInteractionOperand();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_CONSTRAINT: return createBVRInteractionConstraint();
			case Common_Behavior_FragmentsPackage.BVR_GATE: return createBVRGate();
			case Common_Behavior_FragmentsPackage.BVR_COMBINED_FRAGMENT: return createBVRCombinedFragment();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION: return createBVRInteraction();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERATOR: {
				BVRInteractionOperator result = BVRInteractionOperator.get(initialValue);
				if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
				return result;
			}
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OPERATOR:
				return instanceValue == null ? null : instanceValue.toString();
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRInteractionOccurrence createBVRInteractionOccurrence() {
		BVRInteractionOccurrenceImpl bvrInteractionOccurrence = new BVRInteractionOccurrenceImpl();
		return bvrInteractionOccurrence;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRPartDecomposition createBVRPartDecomposition() {
		BVRPartDecompositionImpl bvrPartDecomposition = new BVRPartDecompositionImpl();
		return bvrPartDecomposition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRInteractionOperand createBVRInteractionOperand() {
		BVRInteractionOperandImpl bvrInteractionOperand = new BVRInteractionOperandImpl();
		return bvrInteractionOperand;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRInteractionConstraint createBVRInteractionConstraint() {
		BVRInteractionConstraintImpl bvrInteractionConstraint = new BVRInteractionConstraintImpl();
		return bvrInteractionConstraint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRGate createBVRGate() {
		BVRGateImpl bvrGate = new BVRGateImpl();
		return bvrGate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRCombinedFragment createBVRCombinedFragment() {
		BVRCombinedFragmentImpl bvrCombinedFragment = new BVRCombinedFragmentImpl();
		return bvrCombinedFragment;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRInteraction createBVRInteraction() {
		BVRInteractionImpl bvrInteraction = new BVRInteractionImpl();
		return bvrInteraction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_Behavior_FragmentsPackage getCommon_Behavior_FragmentsPackage() {
		return (Common_Behavior_FragmentsPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	public static Common_Behavior_FragmentsPackage getPackage() {
		return Common_Behavior_FragmentsPackage.eINSTANCE;
	}

} //Common_Behavior_FragmentsFactoryImpl
