/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: BVRMessageImpl.java,v 1.10 2005/03/28 21:51:32 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.interactions.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.hyades.models.common.configuration.CFGOperation;
import org.eclipse.hyades.models.common.interactions.BVRInteractionFragment;
import org.eclipse.hyades.models.common.interactions.BVRMessage;
import org.eclipse.hyades.models.common.interactions.BVRMessageEnd;
import org.eclipse.hyades.models.common.interactions.BVRMessageSort;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage;
import org.eclipse.hyades.models.common.testprofile.TPFInstanceValue;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>BVR Message</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRMessageImpl#getMessageSort <em>Message Sort</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRMessageImpl#getReceiveMessageEnd <em>Receive Message End</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRMessageImpl#getSendMessageEnd <em>Send Message End</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRMessageImpl#getInteractionFragment <em>Interaction Fragment</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRMessageImpl#getInstanceValues <em>Instance Values</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.interactions.impl.BVRMessageImpl#getOperation <em>Operation</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BVRMessageImpl extends EObjectImpl implements BVRMessage
{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "";

	/**
	 * The default value of the '{@link #getMessageSort() <em>Message Sort</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMessageSort()
	 * @generated
	 * @ordered
	 */
	protected static final BVRMessageSort MESSAGE_SORT_EDEFAULT = BVRMessageSort.SYNCH_CALL_LITERAL;

	/**
	 * The cached value of the '{@link #getMessageSort() <em>Message Sort</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMessageSort()
	 * @generated
	 * @ordered
	 */
	protected BVRMessageSort messageSort = MESSAGE_SORT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getReceiveMessageEnd() <em>Receive Message End</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReceiveMessageEnd()
	 * @generated
	 * @ordered
	 */
	protected BVRMessageEnd receiveMessageEnd = null;

	/**
	 * The cached value of the '{@link #getSendMessageEnd() <em>Send Message End</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSendMessageEnd()
	 * @generated
	 * @ordered
	 */
	protected BVRMessageEnd sendMessageEnd = null;

	/**
	 * The cached value of the '{@link #getInstanceValues() <em>Instance Values</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInstanceValues()
	 * @generated
	 * @ordered
	 */
	protected EList instanceValues = null;

	/**
	 * The cached value of the '{@link #getOperation() <em>Operation</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOperation()
	 * @generated
	 * @ordered
	 */
	protected CFGOperation operation = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BVRMessageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Common_Behavior_InteractionsPackage.eINSTANCE.getBVRMessage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRMessageSort getMessageSort() {
		return messageSort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMessageSort(BVRMessageSort newMessageSort) {
		BVRMessageSort oldMessageSort = messageSort;
		messageSort = newMessageSort == null ? MESSAGE_SORT_EDEFAULT : newMessageSort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_MESSAGE__MESSAGE_SORT, oldMessageSort, messageSort));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRMessageEnd getReceiveMessageEnd() {
		if (receiveMessageEnd != null && receiveMessageEnd.eIsProxy()) {
			BVRMessageEnd oldReceiveMessageEnd = receiveMessageEnd;
			receiveMessageEnd = (BVRMessageEnd)eResolveProxy((InternalEObject)receiveMessageEnd);
			if (receiveMessageEnd != oldReceiveMessageEnd) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_Behavior_InteractionsPackage.BVR_MESSAGE__RECEIVE_MESSAGE_END, oldReceiveMessageEnd, receiveMessageEnd));
			}
		}
		return receiveMessageEnd;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRMessageEnd basicGetReceiveMessageEnd() {
		return receiveMessageEnd;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetReceiveMessageEnd(BVRMessageEnd newReceiveMessageEnd, NotificationChain msgs) {
		BVRMessageEnd oldReceiveMessageEnd = receiveMessageEnd;
		receiveMessageEnd = newReceiveMessageEnd;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_MESSAGE__RECEIVE_MESSAGE_END, oldReceiveMessageEnd, newReceiveMessageEnd);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setReceiveMessageEnd(BVRMessageEnd newReceiveMessageEnd) {
		if (newReceiveMessageEnd != receiveMessageEnd) {
			NotificationChain msgs = null;
			if (receiveMessageEnd != null)
				msgs = ((InternalEObject)receiveMessageEnd).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_MESSAGE_END__RECEIVE_MESSAGE, BVRMessageEnd.class, msgs);
			if (newReceiveMessageEnd != null)
				msgs = ((InternalEObject)newReceiveMessageEnd).eInverseAdd(this, Common_Behavior_InteractionsPackage.BVR_MESSAGE_END__RECEIVE_MESSAGE, BVRMessageEnd.class, msgs);
			msgs = basicSetReceiveMessageEnd(newReceiveMessageEnd, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_MESSAGE__RECEIVE_MESSAGE_END, newReceiveMessageEnd, newReceiveMessageEnd));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRMessageEnd getSendMessageEnd() {
		if (sendMessageEnd != null && sendMessageEnd.eIsProxy()) {
			BVRMessageEnd oldSendMessageEnd = sendMessageEnd;
			sendMessageEnd = (BVRMessageEnd)eResolveProxy((InternalEObject)sendMessageEnd);
			if (sendMessageEnd != oldSendMessageEnd) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_Behavior_InteractionsPackage.BVR_MESSAGE__SEND_MESSAGE_END, oldSendMessageEnd, sendMessageEnd));
			}
		}
		return sendMessageEnd;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRMessageEnd basicGetSendMessageEnd() {
		return sendMessageEnd;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSendMessageEnd(BVRMessageEnd newSendMessageEnd, NotificationChain msgs) {
		BVRMessageEnd oldSendMessageEnd = sendMessageEnd;
		sendMessageEnd = newSendMessageEnd;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_MESSAGE__SEND_MESSAGE_END, oldSendMessageEnd, newSendMessageEnd);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSendMessageEnd(BVRMessageEnd newSendMessageEnd) {
		if (newSendMessageEnd != sendMessageEnd) {
			NotificationChain msgs = null;
			if (sendMessageEnd != null)
				msgs = ((InternalEObject)sendMessageEnd).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_MESSAGE_END__SEND_MESSAGE, BVRMessageEnd.class, msgs);
			if (newSendMessageEnd != null)
				msgs = ((InternalEObject)newSendMessageEnd).eInverseAdd(this, Common_Behavior_InteractionsPackage.BVR_MESSAGE_END__SEND_MESSAGE, BVRMessageEnd.class, msgs);
			msgs = basicSetSendMessageEnd(newSendMessageEnd, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_MESSAGE__SEND_MESSAGE_END, newSendMessageEnd, newSendMessageEnd));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRInteractionFragment getInteractionFragment() {
		if (eContainerFeatureID != Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT) return null;
		return (BVRInteractionFragment)eContainer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInteractionFragment(BVRInteractionFragment newInteractionFragment) {
		if (newInteractionFragment != eContainer || (eContainerFeatureID != Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT && newInteractionFragment != null)) {
			if (EcoreUtil.isAncestor(this, newInteractionFragment))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newInteractionFragment != null)
				msgs = ((InternalEObject)newInteractionFragment).eInverseAdd(this, Common_Behavior_InteractionsPackage.BVR_INTERACTION_FRAGMENT__MESSAGES, BVRInteractionFragment.class, msgs);
			msgs = eBasicSetContainer((InternalEObject)newInteractionFragment, Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT, newInteractionFragment, newInteractionFragment));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getInstanceValues() {
		if (instanceValues == null) {
			instanceValues = new EObjectResolvingEList(TPFInstanceValue.class, this, Common_Behavior_InteractionsPackage.BVR_MESSAGE__INSTANCE_VALUES);
		}
		return instanceValues;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGOperation getOperation() {
		if (operation != null && operation.eIsProxy()) {
			CFGOperation oldOperation = operation;
			operation = (CFGOperation)eResolveProxy((InternalEObject)operation);
			if (operation != oldOperation) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_Behavior_InteractionsPackage.BVR_MESSAGE__OPERATION, oldOperation, operation));
			}
		}
		return operation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGOperation basicGetOperation() {
		return operation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOperation(CFGOperation newOperation) {
		CFGOperation oldOperation = operation;
		operation = newOperation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_InteractionsPackage.BVR_MESSAGE__OPERATION, oldOperation, operation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case Common_Behavior_InteractionsPackage.BVR_MESSAGE__RECEIVE_MESSAGE_END:
					if (receiveMessageEnd != null)
						msgs = ((InternalEObject)receiveMessageEnd).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_MESSAGE_END__RECEIVE_MESSAGE, BVRMessageEnd.class, msgs);
					return basicSetReceiveMessageEnd((BVRMessageEnd)otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_MESSAGE__SEND_MESSAGE_END:
					if (sendMessageEnd != null)
						msgs = ((InternalEObject)sendMessageEnd).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_MESSAGE_END__SEND_MESSAGE, BVRMessageEnd.class, msgs);
					return basicSetSendMessageEnd((BVRMessageEnd)otherEnd, msgs);
				case Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT:
					if (eContainer != null)
						msgs = eBasicRemoveFromContainer(msgs);
					return eBasicSetContainer(otherEnd, Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case Common_Behavior_InteractionsPackage.BVR_MESSAGE__RECEIVE_MESSAGE_END:
					return basicSetReceiveMessageEnd(null, msgs);
				case Common_Behavior_InteractionsPackage.BVR_MESSAGE__SEND_MESSAGE_END:
					return basicSetSendMessageEnd(null, msgs);
				case Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT:
					return eBasicSetContainer(null, Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
				case Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT:
					return ((InternalEObject)eContainer).eInverseRemove(this, Common_Behavior_InteractionsPackage.BVR_INTERACTION_FRAGMENT__MESSAGES, BVRInteractionFragment.class, msgs);
				default:
					return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return ((InternalEObject)eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__MESSAGE_SORT:
				return getMessageSort();
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__RECEIVE_MESSAGE_END:
				if (resolve) return getReceiveMessageEnd();
				return basicGetReceiveMessageEnd();
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__SEND_MESSAGE_END:
				if (resolve) return getSendMessageEnd();
				return basicGetSendMessageEnd();
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT:
				return getInteractionFragment();
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__INSTANCE_VALUES:
				return getInstanceValues();
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__OPERATION:
				if (resolve) return getOperation();
				return basicGetOperation();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__MESSAGE_SORT:
				setMessageSort((BVRMessageSort)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__RECEIVE_MESSAGE_END:
				setReceiveMessageEnd((BVRMessageEnd)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__SEND_MESSAGE_END:
				setSendMessageEnd((BVRMessageEnd)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT:
				setInteractionFragment((BVRInteractionFragment)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__INSTANCE_VALUES:
				getInstanceValues().clear();
				getInstanceValues().addAll((Collection)newValue);
				return;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__OPERATION:
				setOperation((CFGOperation)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__MESSAGE_SORT:
				setMessageSort(MESSAGE_SORT_EDEFAULT);
				return;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__RECEIVE_MESSAGE_END:
				setReceiveMessageEnd((BVRMessageEnd)null);
				return;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__SEND_MESSAGE_END:
				setSendMessageEnd((BVRMessageEnd)null);
				return;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT:
				setInteractionFragment((BVRInteractionFragment)null);
				return;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__INSTANCE_VALUES:
				getInstanceValues().clear();
				return;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__OPERATION:
				setOperation((CFGOperation)null);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__MESSAGE_SORT:
				return messageSort != MESSAGE_SORT_EDEFAULT;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__RECEIVE_MESSAGE_END:
				return receiveMessageEnd != null;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__SEND_MESSAGE_END:
				return sendMessageEnd != null;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__INTERACTION_FRAGMENT:
				return getInteractionFragment() != null;
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__INSTANCE_VALUES:
				return instanceValues != null && !instanceValues.isEmpty();
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE__OPERATION:
				return operation != null;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (messageSort: ");
		result.append(messageSort);
		result.append(')');
		return result.toString();
	}

} //BVRMessageImpl
