/**********************************************************************
 * Copyright (c) 2005 Scapa Technologies Limited and others
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 * Scapa Technologies Limited - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.perfmon.utils.internal;

public class SetVariableCommand {
	
	public static final String TYPE_STRING = "var_string";
	public static final String TYPE_BOOLEAN = "var_boolean";
	public static final String TYPE_INT = "var_int";
	
	public static final String VAR_FREQUENCY = "DC_WAITTIME";
	public static final String VAR_EXIT = "DC_FINISHED";
	
	public String type;
	public String name;
	public String value;
	
	public SetVariableCommand(String name, String value) {
		this.type = TYPE_STRING;
		this.name = name;
		this.value = value;
	}

	public SetVariableCommand(String name, int value) {
		this.type = TYPE_INT;
		this.name = name;
		this.value = ""+value;
	}

	public SetVariableCommand(String name, boolean value) {
		this.type = TYPE_BOOLEAN;
		this.name = name;
		this.value = ""+value;
	}

}