/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: UntrustedAgentControllerDialog.java,v 1.4 2005/02/16 22:21:33 qiyanli Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.security.util;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Label;

import org.eclipse.hyades.security.SecurityPlugin;

public class UntrustedAgentControllerDialog extends Dialog {

    private ConnectivityUI _connectivityUI;
    private String fDescription;
    private boolean fSelectUserField=true;
	
	public UntrustedAgentControllerDialog(Shell shell){
		this(shell, "", "", true);
	}
	
	public UntrustedAgentControllerDialog(Shell shell, String userId){
		this(shell, userId, "", true);
	}
	
	public UntrustedAgentControllerDialog(Shell shell, String userId, boolean selectUserField){
		this(shell, userId, "", selectUserField);
	}	

	public UntrustedAgentControllerDialog(Shell shell, String userId, String password, boolean selectUserField){
		super(shell);
		fSelectUserField = selectUserField;
	}
	
	protected Control createDialogArea(Composite parent){ 

		getShell().setText(SecurityPlugin.getResourceString("SEC_MSG"));
		Composite content = new Composite(parent, SWT.NULL);
		GridLayout layout = new GridLayout();
		GridData data = GridUtil.createFill();
		layout.numColumns = 1;
		content.setLayout(layout);
		content.setLayoutData(data);
		

		Label label = new Label(content, SWT.NONE);
		data = new GridData();
		data.horizontalSpan = 2;
		label.setLayoutData(data);
		String text = fDescription+"\n";
		label.setText(text);				
		return content;
	}
	
	protected Control createButtonBar(Composite parent) {
		Control control = super.createButtonBar(parent);
		getShell().setDefaultButton(getButton(IDialogConstants.OK_ID));
		return control;
		
	}
	

    public void setDescription(String desc)
    {
    	fDescription = desc;
    }	
}
